PROGRAM STARDUST;

uses constype,fonscal,wincrt,fonvect,inj_heli,dates,RVPARAM,PARAMRV,
     TERRE,BIPOSE,BIPOS;

 var vitesse_helio0,rayon_helio0,rayon_helio1,vitesse_helio1,rayon_helio_correction,vitesse_helio_correction:vecteur;
     declinaison,ascension_droite,C3,mu,rayon_sphere,date_calcul_correction:real;
     datetir0,heuretir0,datetir,heuretir,date_survol_tremplin_terre,heure_survol_terre:string;
     ch:char;
     param0,param1:tabparam;
     vitarrivee,vitesse_helio_terre1,vit_infinie_arrivee_terre,Vitesse_helio_arrivee:vecteur;
     C3_T_ARRIVEE,altitude_survol_tremplin,psi:real;
     date_entree,heure_entree:string;
     vit_infinie_sortie,Vitesse_helio_depart,rayon_comete,vit_helio_depart,vit_helio_arrivee_comete:vecteur;
     vitesse_helio_sortie:vecteur;
     Dv_min,DVMIN_MIN,Altitude_optimale,PSIMIN_MIN,PSI_MIN:real;
     i:integer;
     {------------------------------------------------------------------------------------}

  FUNCTION ANGLE_TERRE_SOLEIL_SONDE(date,heure:string;rayon_sonde:vecteur):real;   { Sortie en radian }
   Var date_jour,date_heure:string;
       paramT:tabparam;
       rayon_terre,vitesse_terre:vecteur;
  BEGIN

     date_jour:=date;
     date_heure:=heure;
     ephemterre(date_jour,date_heure,mus,0,paramT,rayon_terre,vitesse_terre);

     ANGLE_TERRE_SOLEIL_SONDE:=ANGVECT(rayon_terre,rayon_sonde);


  END;

 { ------------------------------------------------------------------------------------------------------}

 PROCEDURE DATE_ENTREE_SPHERE(date_survol_tremplin_terre,heure_survol_terre:string;Var date_entree,heure_entree:string);


 Var traversee,JJdateTir0,JJdateTir:real;


 BEGIN

 traversee:=Rayon_sphere/sqrt(C3_T_ARRIVEE);

 JJdateTir0:=JourJulien(date_survol_tremplin_terre,heure_survol_terre);  { Date julienne du survol hyperbolique }
 JJdateTir:=JJdatetir0-Traversee/86400;       { Date julienne d'entre d'influence}

 Date_entree:=DateSimple(JJdateTir);               { Date 'STRING' d'entre sphre d'influence}
 Heure_Entree:=HeureSimple(JJdateTir);             { Heure 'STRING' d'entre sphre d'influence}


 END;

{------------------------------------------------------------------------------------}

PROCEDURE DONNEES_MISSION;

Var k:real;
    ch:char;

BEGIN

  k:=pi/180;
  Rayon_sphere:=880000;
  Mu:=Mus;

  { ************** Donnes en degrs converties en radian, NASA - JPL **********************}
  declinaison:=-19.5*k;ascension_droite:=234.62*k;datetir0:='06021999'; Heuretir0:='120000';
  {declinaison:=-20.69*k;ascension_droite:=240.69*k;datetir0:='12021999'; Heuretir0:='120000';}
  {declinaison:=-16.02*k;ascension_droite:=221.48*k;datetir0:='15021999'; Heuretir0:='120000';}
  {declinaison:=-17.84*k;ascension_droite:=227.93*k;datetir0:='21021999'; Heuretir0:='120000'; }
  C3:=26;                         { En km/s}

  { ********************  Date de survol de la Terre pour le tremplin ***********************}
  date_survol_tremplin_terre:='15012001';
  heure_survol_terre:='120000';
  altitude_survol_tremplin:=8000;      { En km / sol terrestre }

  {--------------  ECRITURE DES DONNEES INITIALES --------------------}
  
  WriteLn;
  WriteLn('     ****************** MISSION STAR DUST ( NASA - JPL ) *******************');
  WriteLn;
  WriteLn('     CONDITIONS DU TIR HYPERBOLIQUE TERRESTRE LE ',datetir0,'  ',heuretir0);
  WriteLn;
  WriteLn('          Dclinaison      = ',(declinaison*180/pi):8:3,' degrs');
  WriteLn('          Ascension droite = ',(ascension_droite*180/pi):8:3,' degrs');
  WriteLn('          Constante C3     = ',C3:7:3,' km/s2');
  WriteLn;
  WriteLn;
  WriteLn;
  WriteLn('     CHOIX DE L''ALTITUDE DE SURVOL LORS DU TREMPLIN SUR LA TERRE ');
  WriteLn('          **     LA NASA AVAIT PREVU 6000 KM    ***');
  WriteLn;
  Write('     Donnez votre choix entre 2000 et 20000 km ---> ALTITUDE EN KM ? :');ReadLn(altitude_survol_tremplin);

  clrscr;
  { --------------------------------------------------------------------------------------}

  { EPHEMERIDES COMETE WILD-2 LE 2/1/2004 12 h 00 00}

        rayon_comete[1]:=-171.47365e6;
        rayon_comete[2]:=-218.18235e6;
        rayon_comete[3]:=15.63268e6;


END;

{------------------------------------------------------------------------------------}

 PROCEDURE DATE_SORTIE_SPHERE(datetir0,heuretir0:string;Var datetir,heuretir:string);


 Var traversee,JJdateTir0,JJdateTir:real;


 BEGIN

 traversee:=Rayon_sphere/sqrt(C3);

 JJdateTir0:=JourJulien(datetir0,heuretir0);  { Date julienne du tir  l'injection hyperbolique }
 JJdateTir:=JJdatetir0+Traversee/86400;       { Date julienne de sortie sphre d'influence}

 Datetir:=DateSimple(JJdateTir);               { Date 'STRING' de sortie sphre d'influence}
 HeureTir:=HeureSimple(JJdateTir);             { Heure 'STRING' de sortie sphre d'influence}


 END;

{------------------------------------------------------------------------------------}

 PROCEDURE ORBITE0_AVANT_CORRECTION;

 Var ch:char;

 BEGIN
  { ********* Calcul de la position et vitesse hliocentrique au sortir sphre influence Terre ********* }

  VITESSE_INFINIE_TERREtoVITESSE_HELIO(declinaison,ascension_droite,C3,Rayon_sphere,Mu,
                                 datetir0,heuretir0,vitesse_helio0,rayon_helio0);

  {************* Calcul de la date d'injection hliocentrique hors sphre influence **************}

  DATE_SORTIE_SPHERE(datetir0,heuretir0,datetir,heuretir);  { Donnent les 'string' pour date et heure}


  {************* Calcul des paramtres orbitaux de la premire orbite **************}

  POSVITPARAM(rayon_helio0,vitesse_helio0,datetir,heuretir,mu,param0);

  WriteLn;

  { ----------------------  ECRITURE DES CALCULS INTERMEDIAIRES -----------------------}
   clrscr;
   WriteLn('     EPHEMERIDES DE LA SONDE A L''INJECTION HELIOCENTRIQUE LE ',datetir,'  ',heuretir);
   WriteLn('               X= ',(rayon_helio0[1]/1e6):9:4,' e6  km');
   WriteLn('               Y= ',(rayon_helio0[2]/1e6):9:4,' e6  km');
   WriteLn('               Z= ',(rayon_helio0[3]/1e6):9:4,' e6  km');WriteLn;

   WriteLn('               Vx= ',vitesse_helio0[1]:8:3,' km/s');
   WriteLn('               Vy= ',vitesse_helio0[2]:8:3,' km/s');
   WriteLn('               Vz= ',vitesse_helio0[3]:8:3,' km/s');WriteLn;


   WriteLn('     PARAMETRES ORBITAUX AVANT CORRECTION HELIOCENTRIQUE');
   WriteLn('               a  = ',(param0[1]/1e6):9:4,' e6  km');
   WriteLn('               e  = ',param0[2]:7:6);
   WriteLn('               i  = ',(param0[3]*180/pi):7:3,' degrs');
   WriteLn('               w  = ',(param0[4]*180/pi):7:3,' degrs');
   WriteLn('               W  = ',(param0[5]*180/pi):7:3,' degrs');
   WriteLn('               phi= ',(param0[6]*180/pi):7:3,' degrs');
   WriteLn('               Tp = ', param0[7]:10:5,' Jours Juliens');WriteLn;

   WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');
   WriteLn;
   WriteLn('                  PATIENTEZ LES CALCULS SONT LONGS !!!');
   ch:=readkey; clrscr;


 END;

 {------------------------------------------------------------------------------------}

  PROCEDURE OPTIMISATION_CORRECTION;

  { *******************************************************************************************
    *Elle consiste, sur la premire orbite  dterminer le point et la date 1 o la correction*
    *de trajectoire qui fait passer de ce point  la Terre  la date 2, pour un tremplin est  *
    *optimale( MINIMISATION DU DV )                                                           *
    *******************************************************************************************}


  VAR periode0,intervalle,duree,duree_apres_correction,align,align_correction:real;
      date_calcul,temps_debut,temps_fin,angle_phi:real;
      param0_modifie,paramT,parametres:tabparam;
      p,q,w,r,v,rd,ra,vitdepart,rayon_helio_terre1:vecteur;
      i,imprim,cas:integer;
      result,DeltaVitesse,rayon_helio1,vitesse_helio1:vecteur;
      deltaV,DeltaV_ancien,Phi_correction:real;
      Date_correction,datedepart,heuredepart,date,heure:string;
      bool:boolean;
  BEGIN

   { BALAYAGE DES POSITIONS ET CALCUL DE DV 180 jours aprs le prige et 30 avant le suivant
   }
  periode0:=2*pi*(param0[1]*sqrt(param0[1]/mus))/86400; { Priode 0 en jours dcimaux}
  intervalle:=2;  { jours }
  temps_debut:= param0[7]+280;temps_debut:=Int(temps_debut/intervalle)*intervalle;    { Calcul en jours JJ}
  temps_fin:=param0[7]+periode0-30;temps_fin:= Int(temps_fin/intervalle)*intervalle;  { Calcul en jours JJ}


  { ---- Calcul de la position terre  la date du tremplin }

  ephemterre(date_survol_tremplin_terre,heure_survol_terre,mus,0,paramT,rayon_helio_terre1,vitesse_helio_terre1);

  { ------------ }

  date_calcul:=temps_debut; { Initialisation de la boucle }
  DeltaV_ancien:=10000;
  duree_apres_correction:=0;

  while date_calcul<=temps_fin  do
      BEGIN
         {--- Calcul de la position-vitesse  le long de l'orbite,  intervalles rguliers }
         angle_phi:=0;
         for i:=1 to 10 do
            begin
             angle_phi:=param0[2]*sin(angle_phi)+2*pi/periode0*(date_calcul-param0[7]); { Anomalie excentrique en rd }
            end;

         param0_modifie:=param0;
         param0_modifie[6]:=angle_phi;
         posvitperifocal(mus,param0_modifie,p,q,w,rayon_helio1,vitesse_helio1);

         { ------  Calcul du vol de Lambert entre les 2 points -------}

         duree:=JourJulien(date_survol_tremplin_terre,heure_survol_terre)-date_calcul;

         Rd[1]:=rayon_helio1[1];
         Rd[2]:=rayon_helio1[2];
         Rd[3]:=rayon_helio1[3];

         Ra[1]:=rayon_helio_terre1[1];
	 Ra[2]:=rayon_helio_terre1[2];
	 Ra[3]:=rayon_helio_terre1[3];

         cas:=1;

         ELLIPSE2POINTS(Rd,Ra,duree,mus,cas,vitdepart,vitarrivee);

         { ---------------- Calcul de l'incrment de vitesse et de son minimum ----------
                       En vrifiant que l'angle Terre Soleil Sonde est <>3 ou < 177 }

         Scalvect(-1,vitesse_helio1,result);
         SOMME(result,vitdepart,DeltaVitesse);

         DeltaV:=norm(DeltaVitesse);
         date:=DateSimple(date_calcul);
         heure:=HeureSimple(date_calcul);
         Align:=ANGLE_TERRE_SOLEIL_SONDE(date,heure,rayon_helio1)*180/pi;

         bool:= (DeltaV<=DeltaV_ancien) and ((align>3) and(align<177));

         if bool then

          BEGIN

              DeltaV_ancien:=DeltaV;
              Date_correction:=DateNormale(date_calcul); { Date_calcul EN JOURS JULIENS et date_correction calendaire }
              Phi_correction:=Angle_Phi;
              duree_apres_correction:=duree;
              align_correction:=align;
              date_calcul_correction:=date_calcul;
              rayon_helio_correction:=rayon_helio1;
              vitesse_helio_correction:=vitdepart;
              Vitesse_helio_arrivee:=vitarrivee;

          END;

         { -------- Incrementation de la date pour la boucle ---------}

        date_calcul:=date_calcul+intervalle;


      END;


   { ECRITURES DES RESULTATS HORS DE LA BOUCLE } 

   WriteLn;
   WriteLn(' ****************** PREMERE ITERATION DU SURVOL ***********************');
   WriteLn;
   WriteLn('     PERIODE AVANT CORRECTION = ',periode0:8:3,' Jours');
   WriteLn('     DUREE DU VOYAGE RESTANT APRES CORRECTION = ',duree_apres_correction :8:3);
   WriteLn('     EPHEMERIDES DE LA TERRE LORS DU TREMPLIN LE ',date_survol_tremplin_terre);
   WriteLn('               X= ',(rayon_helio_terre1[1]/1e6):9:4,' e6  km');
   WriteLn('               Y= ',(rayon_helio_terre1[2]/1e6):9:4,' e6  km');
   WriteLn('               Z= ',(rayon_helio_terre1[3]/1e6):9:4,' e6  km');WriteLn;

   WriteLn('               Vx= ',vitesse_helio_terre1[1]:8:3,' km/s');
   WriteLn('               Vy= ',vitesse_helio_terre1[2]:8:3,' km/s');
   WriteLn('               Vz= ',vitesse_helio_terre1[3]:8:3,' km/s');WriteLn;

   WriteLn('     Minimum correction DV =',(DeltaV_ancien*1000):7:2,' m/s','  la date : ',Date_correction);
   WriteLn('     Correction au point d''anomalie excentrique PHI = ',(Phi_correction*180/pi):7:2,' degrs');
   WriteLn;
   WriteLn('     Angle Terre-Soleil-Sonde gal  :',align_correction:6:2,' degrs'); WriteLn;
   WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');ch:=readkey;


END;

 { ------------------------------------------------------------------------------------------------------}

 PROCEDURE ORBITE_AVANT_TREMPLIN(R,V:vecteur;DATE:real;PARAM1:tabparam);


 Var periode1:real;

 BEGIN

    datetir:=DateSimple(Date_Calcul_Correction);
    Heuretir:=HeureSimple(Date_Calcul_Correction);
    POSVITPARAM(R,V,datetir,heuretir,mus,param1);

    periode1:=2*pi*(param1[1]*sqrt(param1[1]/mus))/86400; { Priode 1 en jours dcimaux}

    WriteLn;
    WriteLn('     PARAMETRES ORBITAUX APRES CORRECTION HELIOCENTRIQUE');
    WriteLn('               a  = ',(param1[1]/1e6):9:4,' e6  km');
    WriteLn('               e  = ',param1[2]:7:6);
    WriteLn('               i  = ',(param1[3]*180/pi):7:3,' degrs');
    WriteLn('               w  = ',(param1[4]*180/pi):7:3,' degrs');
    WriteLn('               W  = ',(param1[5]*180/pi):7:3,' degrs');
    WriteLn('               phi= ',(param1[6]*180/pi):7:3,' degrs');
    WriteLn('               Tp = ', param1[7]:10:5,' Jours Juliens');WriteLn;

    WriteLn('      Nouvelle priode : T1 = ',periode1,' Jours'); WriteLn;
    WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');ch:=readkey;

 END;

   { ------------------------------------------------------------------------------------------------------}
    PROCEDURE VITESSE_INFINIE_ARRIVEE(Param1:tabparam;date_survol_tremplin_terre,heure_survol_terre:string;
                 Var vit_infinie_arrivee_terre:vecteur;Var C3_T_ARRIVEE:real);
       Var result:vecteur;

     BEGIN

          Scalvect(-1,vitesse_helio_terre1,result);
          Somme(result,Vitesse_helio_arrivee,vit_infinie_arrivee_terre);
          C3_T_ARRIVEE:=Puiss(norm(vit_infinie_arrivee_terre),2);

          WriteLn;
          WriteLn('     **************** ETUDE DU TREMPLIN SUR LA TERRE *******************');WriteLn;
          WriteLn('     Date '); WriteLn;

          WriteLn('     VITESSE HELIOCENTRIQUE D''ARRIVEE :');
          WriteLn('               Vx= ',Vitesse_helio_arrivee[1]:8:3,' km/s');
          WriteLn('               Vy= ',Vitesse_helio_arrivee[2]:8:3,' km/s');
          WriteLn('               Vz= ',Vitesse_helio_arrivee[3]:8:3,' km/s');WriteLn;

          WriteLn('     VITESSE HELIOCENTRIQUE DE  LA TERRE :');
          WriteLn('               Vx= ',vitesse_helio_terre1[1]:8:3,' km/s');
          WriteLn('               Vy= ',vitesse_helio_terre1[2]:8:3,' km/s');
          WriteLn('               Vz= ',vitesse_helio_terre1[3]:8:3,' km/s');WriteLn;

          WriteLn('     VITESSE INFINIE D''ARRIVEE :');
          WriteLn('               Vinfx= ',vit_infinie_arrivee_terre[1]:8:3,' km/s');
          WriteLn('               Vinfy= ',vit_infinie_arrivee_terre[2]:8:3,' km/s');
          WriteLn('               Vinfz= ',vit_infinie_arrivee_terre[3]:8:3,' km/s');WriteLn;

          WriteLn('     Constante C3 du tremplin C3 = ',C3_T_ARRIVEE,' km/s');

     END;

   { ------------------------------------------------------------------------------------------------------}

   PROCEDURE OPTIMISATION_CORRECTION_NOUVELLE;

  { *******************************************************************************************
    *Elle consiste, sur la premire orbite  dterminer le point et la date 1 o la correction*
    *de trajectoire qui fait passer de ce point  la Terre  la date 2, pour un tremplin est  *
    *optimale( MINIMISATION DU DV )                                                           *
    *******************************************************************************************}


  VAR periode0,intervalle,duree,duree_apres_correction,align,align_correction:real;
      date_calcul,temps_debut,temps_fin,angle_phi:real;
      param0_modifie,paramT,parametres:tabparam;
      p,q,w,r,v,rd,ra,vitdepart,rayon_helio_terre1:vecteur;
      i,imprim,cas:integer;
      result,DeltaVitesse,rayon_helio1,vitesse_helio1:vecteur;
      deltaV,DeltaV_ancien,Phi_correction:real;
      Date_correction,datedepart,heuredepart,date,heure:string;
      bool:boolean;
      rayon_helio_entree,vitesse_helio_entree,vinf_unit:vecteur;
  BEGIN

   { BALAYAGE DES POSITIONS ET CALCUL DE DV 180, jours aprs le prige et 30 avant le suivant }

  periode0:=2*pi*(param0[1]*sqrt(param0[1]/mus))/86400; { Priode 0 en jours dcimaux}
  intervalle:=2;  { jours }
  temps_debut:= param0[7]+280;temps_debut:=Int(temps_debut/intervalle)*intervalle;    { Calcul en jours JJ}
  temps_fin:=param0[7]+periode0-30;temps_fin:= Int(temps_fin/intervalle)*intervalle;  { Calcul en jours JJ}

  { --------------------- CONDITIONS DE RENTREE SPHERE TERRE --------------------}

  DATE_ENTREE_SPHERE(date_survol_tremplin_terre,heure_survol_terre,date_entree,heure_entree);

  { ---- Calcul de la position terre  la date du tremplin qui n'a pas chang}

  ephemterre(date_entree,heure_entree,mus,0,paramT,rayon_helio_entree,vitesse_helio_entree);

  { ------------ }

  date_calcul:=temps_debut; { Initialisation de la boucle }
  DeltaV_ancien:=10000;
  duree_apres_correction:=0;

  while date_calcul<=temps_fin  do
      BEGIN
         {--- Calcul de la position-vitesse  le long de l'orbite,  intervalles rguliers }
         angle_phi:=0;
         for i:=1 to 10 do
            begin
             angle_phi:=param0[2]*sin(angle_phi)+2*pi/periode0*(date_calcul-param0[7]); { Anomalie excentrique en rd }
            end;

         param0_modifie:=param0;
         param0_modifie[6]:=angle_phi;
         posvitperifocal(mus,param0_modifie,p,q,w,rayon_helio1,vitesse_helio1);

         { ------  Calcul du vol de Lambert entre les 2 points -------}

         duree:=JourJulien(date_entree,heure_entree)-date_calcul;

         Rd[1]:=rayon_helio1[1];
         Rd[2]:=rayon_helio1[2];
         Rd[3]:=rayon_helio1[3];

         unitaire(vit_infinie_arrivee_terre,vinf_unit);

         scalvect(rayon_sphere,vinf_unit,result);

         Ra[1]:=rayon_helio_entree[1]-result[1];
	 Ra[2]:=rayon_helio_entree[2]-result[2];
	 Ra[3]:=rayon_helio_entree[3]-result[3];

         cas:=1;

         ELLIPSE2POINTS(Rd,Ra,duree,mus,cas,vitdepart,vitarrivee);

         { ---------------- Calcul de l'incrment de vitesse et de son minimum ----------
                       En vrifiant que l'angle Terre Soleil Sonde est <>3 ou < 177 }

         Scalvect(-1,vitesse_helio1,result);
         SOMME(result,vitdepart,DeltaVitesse);

         DeltaV:=norm(DeltaVitesse);
         date:=DateSimple(date_calcul);
         heure:=HeureSimple(date_calcul);
         Align:=ANGLE_TERRE_SOLEIL_SONDE(date,heure,rayon_helio1)*180/pi;

         bool:= (DeltaV<=DeltaV_ancien) and ((align>3) and(align<177));

         if bool then

          BEGIN

              DeltaV_ancien:=DeltaV;
              Date_correction:=DateNormale(date_calcul); { Date_calcul EN JOURS JULIENS et date_correction calendaire }
              Phi_correction:=Angle_Phi;
              duree_apres_correction:=duree;
              align_correction:=align;
              date_calcul_correction:=date_calcul;
              rayon_helio_correction:=rayon_helio1;
              vitesse_helio_correction:=vitdepart;
              Vitesse_helio_arrivee:=vitarrivee;

          END;

         { -------- Incrementation de la date pour la boucle ---------}

        date_calcul:=date_calcul+intervalle;


      END;


   { ECRITURES DES RESULTATS HORS DE LA BOUCLE }

   WriteLn;
   WriteLn(' ****************** DEUXIEME ITERATION DU SURVOL ***********************');
   WriteLn;
   WriteLn('     PERIODE AVANT CORRECTION = ',periode0:8:3,' Jours');
   WriteLn('     DUREE DU VOYAGE RESTANT APRES CORRECTION = ',duree_apres_correction :8:3);
   WriteLn('     EPHEMERIDES DE LA TERRE LORS DU TREMPLIN LE ',date_survol_tremplin_terre);
   WriteLn('               X= ',(rayon_helio_terre1[1]/1e6):9:4,' e6  km');
   WriteLn('               Y= ',(rayon_helio_terre1[2]/1e6):9:4,' e6  km');
   WriteLn('               Z= ',(rayon_helio_terre1[3]/1e6):9:4,' e6  km');WriteLn;

   WriteLn('               Vx= ',vitesse_helio_terre1[1]:8:3,' km/s');
   WriteLn('               Vy= ',vitesse_helio_terre1[2]:8:3,' km/s');
   WriteLn('               Vz= ',vitesse_helio_terre1[3]:8:3,' km/s');WriteLn;

   WriteLn('     Minimum correction DV =',(DeltaV_ancien*1000):7:2,' m/s','  la date : ',Date_correction);
   WriteLn('     Correction au point d''anomalie excentrique PHI = ',(Phi_correction*180/pi):7:2,' degrs');
   WriteLn;
   WriteLn('     Angle Terre-Soleil-Sonde gal  :',align_correction:6:2,' degrs'); WriteLn;
   WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');ch:=readkey;


END;

{ --------------------------------------------------------------------------------------------------------}

PROCEDURE VITESSE_INFINIE_SORTIE_TREMPLIN(psi,altitude_survol_tremplin:real;vit_infinie_arrivee_terre:vecteur;
                                          Var vit_infinie_sortie:vecteur);

Var U,V,D_inf,result1,result2,result3,Z:vecteur;
    exc,D,phi_asymptote,A,rayon_perigee,verif:real;
    ch :char;

  BEGIN


  { Calcul du vecteur unitaire U }

  SCALVECT(-1/norm(vit_infinie_arrivee_terre),vit_infinie_arrivee_terre,U);

  { CALCUL DE D infinie et angle phi}

  A:=mut/Prodscal(vit_infinie_arrivee_terre,vit_infinie_arrivee_terre);
  rayon_perigee:=altitude_survol_tremplin+6378;
  exc:=1+rayon_perigee/A;
  phi_asymptote:=Arccos(1/exc);
  D:=A*tan(phi_asymptote);

  Z[1]:=0; Z[2]:=0;Z[3]:=1;

  Scalvect(D*cos(psi),Z,result1);
  Prodvect(U,Z,result2);
  Scalvect(D*sin(psi),result2,result3);

  Somme(result1,result3,D_inf);

  { Calcul de l'unitaire V }

  SCALVECT(1/norm(D_inf),D_inf,V);

  { Calcul vitesse infinie sortie }

  scalvect(cos(2*phi_asymptote),U,result1);
  scalvect(-sin(2*phi_asymptote),V,result2);

  Somme(result1,result2,result3);
  scalvect(norm(vit_infinie_arrivee_terre),result3,vit_infinie_sortie);

 END;

{ --------------------------------------------------------------------------------------------------------}

 { --------------------------------------------------------------------------------------------------------}
 PROCEDURE ITERATION_SUR_PSI(Var vitesse_helio_sortie:vecteur;Var DV_min,PSI_MIN:real );

 Var result,vitesse_obtenue,Delta_V_Correction,rayon_terre,vitesse_sonde_obtenue:vecteur;
     duree,JJdatetir,traversee,Delta_V_Correction_init, DELTAV_MIN,Delta_V:real;
     paramT:tabparam;
     date_sortie,heure_sortie:string;
     ch:char;
     DeltaV_MIN_CORRECTION:vecteur;

 BEGIN


    traversee:=Rayon_sphere/norm(vit_infinie_sortie);
    JJdateTir:=JourJulien('15012001','120000');  { Date julienne du tir  l'injection hyperbolique }
    JJdateTir:=JJdatetir+Traversee/86400;       { Date julienne de sortie sphre d'influence}
    Date_sortie:=DateSimple(JJdateTir);               { Date 'STRING' de sortie sphre d'influence}
    Heure_sortie:=HeureSimple(JJdateTir);

    ephemterre(date_sortie,heure_sortie,mus,0,paramT,rayon_terre,vitesse_helio_sortie);

    Delta_V_Correction_init:=30;
    psi:=0; Psi_min:=0;
    While psi<=2*pi  do

      begin

        VITESSE_INFINIE_SORTIE_TREMPLIN(psi,altitude_survol_tremplin,vit_infinie_arrivee_terre,vit_infinie_sortie);

        { CALCUL DE LA CORRECTION DE TRAJECTOIRE POUR OBTENIR LA VITESSE HELIOCENTRIQUE SORTIE SPHERE ADEQUATE) }

        somme(vitesse_helio_sortie,vit_infinie_sortie,vitesse_obtenue);

        scalvect(-1,vitesse_obtenue,result);

        somme(vitesse_helio_depart ,result,Delta_V_Correction);

         Delta_V:=norm(Delta_V_Correction);
         If Delta_V<=Delta_V_Correction_init then
             BEGIN

                 DV_min:=Delta_V;
                 PSI_MIN:=psi;
                 Delta_V_Correction_init:=Delta_V;
                 vitesse_sonde_obtenue:= vitesse_obtenue;
                 DeltaV_MIN_CORRECTION:= Delta_V_Correction;
               END;

          psi:=psi+pi/360;

      end;

      WriteLn('     ***  VITESSE HELIOCENTRIQUE REQUISE POUR REJOINDRE WILD2 ***');WriteLn;
      WriteLn('     Vitesse_helio_depart(1)=',Vitesse_helio_depart[1]:7:3,' km/s');
      WriteLn('     Vitesse_helio_depart(2)=',Vitesse_helio_depart[2]:7:3,' km/s');
      WriteLn('     Vitesse_helio_depart(3)=',Vitesse_helio_depart[3]:7:3,' km/s');
      WriteLn;


      WriteLn('     ***  VITESSE HELIOCENTRIQUE DE LA TERRE EN FIN DE TREMPLIN ***');WriteLn;
      WriteLn('     Vitesse_helio_sortie(1)=',Vitesse_helio_sortie[1]:7:3,' km/s');
      WriteLn('     Vitesse_helio_sortie(2)=',Vitesse_helio_sortie[2]:7:3,' km/s');
      WriteLn('     Vitesse_helio_sortie(3)=',Vitesse_helio_sortie[3]:7:3,' km/s');
      WriteLn;

      WriteLn('     ***  VITESSE HELIOCENTRIQUE DE STAR DUST EN SORTIE DE TREMPLIN ***');WriteLn;
      WriteLn('     Vitesse_injection_obtenue(1)=',vitesse_sonde_obtenue[1]:7:3,' km/s');
      WriteLn('     Vitesse_injection_obtenue(2)=',vitesse_sonde_obtenue[2]:7:3,' km/s');
      WriteLn('     Vitesse_injection_obtenue(3)=',vitesse_sonde_obtenue[3]:7:3,' km/s');
      WriteLn;
      WriteLn(' ???? Notez vos rsultats avant de passer  la suite, puis appuyez une touche');
      WriteLn; ch:=readkey;

      VITESSE_INFINIE_SORTIE_TREMPLIN(PSI_MIN,altitude_survol_tremplin,vit_infinie_arrivee_terre,
                                          vit_infinie_sortie);


      WriteLn('     ***  VITESSE INFINIE EN SORTIE EN SORTIE DE TREMPLIN POUR PSI=120  ***');WriteLn;
      WriteLn('     Vit_infinie_sortie(1)=',Vit_infinie_sortie[1]:7:3,' km/s');
      WriteLn('     Vit_infinie_sortie(2)=',Vit_infinie_sortie[2]:7:3,' km/s');
      WriteLn('     Vit_infinie_sortie(3)=',Vit_infinie_sortie[3]:7:3,' km/s');
      WriteLn;

      WriteLn('     ***  CORRECTION MINIMALE EN SORTIE DE TREMPLIN POUR PSI=120  ***');WriteLn;
      WriteLn('     DeltaV_MIN_CORRECTION(1)=',DeltaV_MIN_CORRECTION[1]:7:3,' km/s');
      WriteLn('     DeltaV_MIN_CORRECTION(2)=',DeltaV_MIN_CORRECTION[2]:7:3,' km/s');
      WriteLn('     DeltaV_MIN_CORRECTION(3)=',DeltaV_MIN_CORRECTION[3]:7:3,' km/s');
      WriteLn;

      WriteLn('     DELTAV_MIN =',DV_MIN:3:3,' km/s ', ' Pour psi = ',(PSI_MIN*180/pi):7:2,' degrs'); writeLn;
 END;

 { ------------------------------------------------------------------------------------------------------}
  PROCEDURE LAMBERT_INTERMEDIAIRE(var vitesse_helio_depart:vecteur);

    Var date_sortie,heure_sortie:string ;
        JJcomete,JJtremplin,duree :real;
        paramT:tabparam;
        rayon_helio_sortie:vecteur;
        ch:char;

  BEGIN

       DATE_SORTIE_SPHERE(date_survol_tremplin_terre,heure_survol_terre,date_sortie,heure_sortie);

       ephemterre(date_sortie,heure_sortie,mus,0,paramT,rayon_helio_sortie,vitesse_helio_sortie);

       { Normalement,
        aprs le tremplin, on devrait rejoindre la comte. Ce ne peut jamais tre vraiment le cas.
       Donc on calcule par Lambert la trajectoire qui  partir de la position terre au sortir de la sphre
       d'influenceva permettre de rejoindre la comte
    	   Date du tremplin :JJtemplin
           Date de survol comte :JJcomete
           Dure : JJcomete - JJtremplin }

           JJtremplin:=JourJulien(date_sortie,heure_sortie);
           JJcomete:=  JourJulien('02012004','120000');
           duree:= JJcomete - JJtremplin;


  WriteLn('   ************************** LIRE ATTENTIVEMENT ***************************');
  WriteLn;
  WriteLn('   A ce niveau du calcul, le programme a besoin d''utiliser, ce qui est rare,');
  WriteLn('   un voyage de  LAMBERT entre la Terre depuis la position aprs le tremplin,');
  WriteLn('   jusqu'' la position de la Comete WILD-2, mais en faisant un tour de plus ');
  WriteLn('   avant de rejoindre la comte.');
  WriteLn('   Dans ces conditions, il y a 2 solutions possibles et le choix ne peut pas ');
  WriteLn('   tre ralis dans le programme.');
  WriteLn;
  WriteLn('   Il faut donc faire une pause dans ce programme, et lancer LAMBERTC.EXE ');
  WriteLn('   en fournissant les positions Comte et Terre ');
  WriteLn ;
  WriteLn('        rayon_comete[1]:=-171.47365e6 km');
  WriteLn('        rayon_comete[2]:=-218.18235e6 km');
  WriteLn('        rayon_comete[3]:=15.63268e6 km');
  WriteLn;
  WriteLn('    Dure du voyage, que j''ai calcule pour vous :');
  WriteLn('          DUREE =',duree,' Jours Juliens');
  WriteLn;
  WriteLn('   Je fournis aussi la position Terre :');
  WriteLn('        rayon_Terre[1]:= ',rayon_helio_sortie[1],' km');
  WriteLn('        rayon_Terre[2]:=',rayon_helio_sortie[2],' km');
  WriteLn('        rayon_Terre[3]:=',rayon_helio_sortie[3],' km');
  WriteLn;
  WriteLn('    FAITES LE CHOIX QUI DONNE UNE PERIODE PROCHE DE 2 ANS ');
  WriteLn('    Le rsultat intressant  noter est celui de la vitesse sonde au dpart');
  {Write('    Donnez ses composantes: V(1))= ');readLn(vitesse_helio_depart[1]);
  Write('                            V(2))= ');readLn(vitesse_helio_depart[2]);
  Write('                            V(3))= ');readLn(vitesse_helio_depart[3]); }
  WriteLn;
  WriteLn('    *********** APPUYEZ SUR UNE TOUCHE UNE FOIS LE RESULTAT DONNE ***********');

  vitesse_helio_depart[1]:=-32.5973;
  vitesse_helio_depart[2]:=-16.0289;
  vitesse_helio_depart[3]:=2.2461;

 END;

 { ------------------------------------------------------------------------------------------------------}

{ ****************************************** PROGRAMME PRINCIPAL ******************************************}

BEGIN

  DONNEES_MISSION;
  ORBITE0_AVANT_CORRECTION;
  { -------------- PREMIER PASSAGE EN OUBLIANT LA SPHERE D'INFLUENCE DE LA TERRE --------------------}
  OPTIMISATION_CORRECTION;
  ORBITE_AVANT_TREMPLIN(Rayon_helio_correction,Vitesse_helio_correction,Date_calcul_correction,PARAM1);
  VITESSE_INFINIE_ARRIVEE(Param1,date_survol_tremplin_terre,heure_survol_terre,
                 vit_infinie_arrivee_terre,C3_T_ARRIVEE);

  { ----- DEUXIEME PASSAGE AVEC LA SPHERE D'INFLUENCE DE LA TERRE ET CONNAISSANT V_INFINIE ------------}
  { Ce qui change, seulement la position du point d'entre dans la sphre d'influence de la Terre et la
  date d'entre qui dpend du temps de decente sur la premire branche de l'hyperbole                   }

  OPTIMISATION_CORRECTION_NOUVELLE;
  ORBITE_AVANT_TREMPLIN(Rayon_helio_correction,Vitesse_helio_correction,Date_calcul_correction,PARAM1);
  {VITESSE_INFINIE_ARRIVEE(Param1,date_survol_tremplin_terre,heure_survol_terre,
                 vit_infinie_arrivee_terre,C3_T_ARRIVEE);}

  LAMBERT_INTERMEDIAIRE(vitesse_helio_depart);

  VITESSE_INFINIE_SORTIE_TREMPLIN(psi,altitude_survol_tremplin,vit_infinie_arrivee_terre,
                                       vit_infinie_sortie);
  ITERATION_SUR_PSI(vitesse_helio_sortie,DV_min,PSI_MIN );


  WriteLn('     MINIMUM DV = ', DV_min:6:3,' km/s ',' Pour PSI= ',
  (PSI_MIN*180/pi):7:3,' degrs', ' Avec survol ',altitude_survol_tremplin:5:0 ,' km');


  { -----------------------------------------------------------------------------------------------------}

    { ***********  ARRET PAR  UNE TOUCHE ************** ET SORTIE FINALE ***********}

  ch:=readkey;DoneWinCrt;


 END.
